-- untimed !

-- lo=length optimized
-- wo=weight optimized


with Ada.Text_Io, Ada.Integer_Text_Io, Scrabble_Types;
use Ada.Text_Io, Ada.Integer_Text_Io, Scrabble_Types;

procedure dic_converter is
   num_words: constant := 10;
   
--   a b c d e f g h i j k l m n o p q r s t u v w x y z
--   1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6
   
   MyWeights : constant array (1..26) of Positive :=
     (17 => 10, 26 => 10,
      10 => 8, 24 => 8,
      11 => 5,
      6 => 4, 8 => 4, 22 => 4, 23 => 4, 25 => 4,
      2 => 3, 3 => 3, 13 => 3, 16 => 3,
      4 => 2, 7 => 2,
      others => 1);  --  "esarintulo" : 10 letters to 1 point each.

   type arr1 is array (1..26) of Integer;
   type arr2 is array (0..8, 1..26) of Integer;
   type arr3 is array (0..26) of Integer;
   
   type Words is
      record
         original_word: String(1..24);
         length: Integer;
         scrabble_value: Integer:=0;
         char_map: arr1 :=(others=>0);
         quick_check: arr3 :=(others=>0);
         failure_jump: arr2;
      end record;

   word_list_lo: array(1..num_words) of Words;
   file: File_Type;
   input: String(1..30);
   length: Integer;
   temp: Integer;
   
begin
   Open(file, In_File, "test.txt");
      for i in 1..num_words loop
         Get_line(file, input, length);
         word_list_lo(i).original_word(1..length):=input(1..length);
         word_list_lo(i).length:=length;
         for j in 1..length loop
            temp:=Character'Pos(input(j))-Character'Pos('a')+1;
            if temp < 1 then
               temp:=temp-Character'Pos('A')+Character'Pos('a');
            end if;
            word_list_lo(i).char_map(temp):=word_list_lo(i).char_map(temp)+1;
            word_list_lo(i).scrabble_value:=word_list_lo(i).scrabble_value+MyWeights(temp);
         end loop;
         
         -- calc quick_check
         temp:=27;
         for j in reverse 0..26 loop
            word_list_lo(i).quick_check(j):=temp;
            if j>0 and then word_list_lo(i).char_map(j) > 0 then
               temp:=j;
            end if;
         end loop;
      end loop;
      
      for i in 1..num_words loop
         for l in 1..26 loop
            for j in 0..8 loop
               word_list_lo(i).failure_jump(j, l):=num_words+1;
            end loop;
            for j in reverse i+1..num_words loop
               for k in word_list_lo(j).char_map(l)..8 loop
                  word_list_lo(i).failure_jump(k, l):=j;
               end loop;
            end loop;   
         end loop;
      end loop;
   Close(file);
   
   -- debug
   
   Create (file, out_file, "debug.txt");
   Set_Output(file);
   
   for i in 1..num_words loop
      Put(i, 0);
      Put(" - ");
      Put(word_list_lo(i).original_word(1..word_list_lo(i).length));
      Put(word_list_lo(i).scrabble_value);
      New_line;
      Put("   ");
      for j in 1..26 loop
         Put(j, 3);
      end loop;
      New_line;
      Put("   ");
      for j in Small_Letters loop
         Put("  ");
         Put(j);
      end loop;
      New_line(2);
      Put("   ");      
      for j in 1..26 loop
         Put(word_list_lo(i).char_map(j), 3);
      end loop;
      New_line;
      for j in 0..26 loop
         Put(word_list_lo(i).quick_check(j), 3);
      end loop;
      New_line(2);
      for j in 0..8 loop
         Put(j, 0);
         Put("  ");
         for k in 1..26 loop
            Put(word_list_lo(i).failure_jump(j, k), 3);
         end loop;
         New_line;
      end loop;
      New_line(3);
   end loop;
   Set_output(Standard_Output);
   Close(file);
end dic_converter;